"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HandleCommands = void 0;
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var HandleCommands = /** @class */ (function () {
    function HandleCommands(io, datadir) {
        this.socketServer = io;
        this.datadir = datadir;
    }
    HandleCommands.prototype.handleCommands = function () {
        var _this = this;
        this.socketServer.onConnection(function (socket) {
            socket.on('rename', function (msg) {
                var renameData = JSON.parse(msg); //eslint-disable-line
                _this.createPath(renameData.old, function (old) {
                    _this.createPath(renameData.new, function (newP) {
                        fs.rename(old, newP, function (err) {
                            if (err) {
                                console.error(err);
                            }
                        });
                    });
                });
            });
            socket.on('save-file', function (msg) {
                var saveData = JSON.parse(msg); //eslint-disable-line
                _this.createPath2(saveData.fullpath, function (thePath) {
                    fs.writeFile(thePath, saveData.data, function (err) {
                        if (err) {
                            console.error("could not save file");
                        }
                    });
                });
            });
        });
    };
    HandleCommands.prototype.createPath2 = function (np, callback) {
        var normalizedDir = path.normalize(np);
        if (normalizedDir.startsWith("..")) {
            console.error("path outside of context");
        }
        callback(path.join(this.datadir, np));
    };
    HandleCommands.prototype.createPath = function (np, callback) {
        this.createPath2(path.join(np.dir, np.base), callback);
    };
    return HandleCommands;
}());
exports.HandleCommands = HandleCommands;
