"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeNativeHTTPrequest = void 0;
var http = __importStar(require("http"));
var p20 = __importStar(require("pareto-20"));
function makeNativeHTTPrequest(options) {
    return p20.wrapUnsafeFunction(function (onError, onSucces) {
        var request = http.request({
            host: options.host,
            path: options.path,
            timeout: options.timeout,
        }, function (res) {
            if (res.statusCode !== 200) {
                onError("'".concat(options.path, "' not found"));
                return;
            }
            //below code is streaming but unstable
            // onSucces(p20.createStream((_limiter, consumer) => {
            //     res.on('data', chunk => {
            //         res.pause()
            //         consumer.onData(chunk.toString()).handle(
            //             _abortRequested => {
            //                 res.resume()
            //             }
            //         )
            //     })
            //     res.on('end', () => {
            //         consumer.onEnd(false, null)
            //     })
            // }))
            var complete = "";
            onSucces(p20.createStream(function (_limiter, consumer) {
                res.on('data', function (chunk) {
                    complete += chunk.toString(); //eslint-disable-line
                });
                res.on('end', function () {
                    consumer.onData(complete).handle(function (_abortRequested) {
                        //
                        consumer.onEnd(false, null);
                    });
                });
            }));
        });
        request.on('timeout', function () {
            console.error("timeout");
            onError("timeout");
        });
        request.on('error', function (e) {
            console.error(e.message);
            onError(e.message);
        });
        request.end();
    });
}
exports.makeNativeHTTPrequest = makeNativeHTTPrequest;
